/*
 * Maxport
 *
 * David Harrison
 * University of California, Berkley
 * 1990
 *
 * Maxport is a subclass of the Athena Viewport widget that allows
 * the caller to specify a maximum width and height.  This is useful
 * if you have a child widget that starts out very large and you
 * would like to force the viewport to scroll initially.
 *
 * These are the public definitions for using the class.
 */
 
#ifndef _Maxport_h
#define _Maxport_h

#include <X11/Xaw/Form.h>
#include <X11/Xaw/Viewport.h>

/* Resources:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 allowHoriz	     Boolean		Boolean		False
 allowVert	     Boolean		Boolean		False
 background	     Background		Pixel		XtDefaultBackground
 border		     BorderColor	Pixel		XtDefaultForeground
 borderWidth	     BorderWidth	Dimension	1
 destroyCallback     Callback		Pointer		NULL
 foreceBars	     Boolean		Boolean		False
 height		     Height		Dimension	0
 maxHeight	     Height		Dimension	0
 maxWidth	     Width		Dimension	0
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 sensitive	     Sensitive		Boolean		True
 useBottom	     Boolean		Boolean		False
 useRight	     Boolean		Boolean		False
 width		     Width		Dimension	0
 x		     Position		Position	0
 y		     Position		Position	0

*/

#define XtNmaxHeight	"maxHeight"
#define XtNmaxWidth	"maxWidth"

extern WidgetClass maxportWidgetClass;

typedef struct _MaxportClassRec *MaxportWidgetClass;
typedef struct _MaxportRec	*MaxportWidget;

#endif /* _Maxport_h */
