/*
 * Maxport
 *
 * David Harrison
 * University of California, Berkley
 * 1990
 *
 * Maxport is a subclass of the Athena Viewport widget that allows
 * the caller to specify a maximum width and height.  This is useful
 * if you have a child widget that starts out very large and you
 * would like to force the viewport to scroll initially.
 *
 * These are the private definitions for subclassing the class.
 */

#ifndef _MaxportP_h
#define _MaxportP_h

#include "Maxport.h"
#include <X11/Xaw/ViewportP.h>
#include <X11/Xaw/FormP.h>

typedef struct {int empty;} MaxportClassPart;

typedef struct _MaxportClassRec {
    CoreClassPart	core_class;
    CompositeClassPart	composite_class;
    ConstraintClassPart	constraint_class;
    FormClassPart	form_class;
    ViewportClassPart	viewport_class;
    MaxportClassPart	maxport_class;
} MaxportClassRec;

extern MaxportClassRec maxportClassRec;

typedef struct _MaxportPart {
    /* resources */
    Dimension max_width;	/* Maximum width  */
    Dimension max_height;	/* Maximum height */
    /* private state */
} MaxportPart;

typedef struct _MaxportRec {
    CorePart	core;
    CompositePart	composite;
    ConstraintPart	constraint;
    FormPart		form;
    ViewportPart	viewport;
    MaxportPart		maxport;
} MaxportRec;

#endif /* _MaxportP_h */
