/*
 * Top level interface for graphic file browser
 *
 * David Harrison
 * University of California, Berkeley
 * 1990
 *
 * These are the external definitions for the file browser.
 * This is an X toolkit library and requires the athena
 * widget set.
 */

#ifndef _BROWSER_H_
#define _BROWSER_H_

#include "ansi.h"
#include <X11/Intrinsic.h>

typedef struct fb_item_defn {
    String class;		/* Defines the image          */
    String name;		/* Name displayed under image */
    caddr_t data;		/* User specific data         */
} fb_item;

extern Widget fb_create
  ARGS((Widget parent, int num_items, fb_item items[],
	void (*callback) ARGS((String class, String label,
			       caddr_t item_data, caddr_t global_data)),
	caddr_t data));
  /* Creates a new file browser */

extern void fb_update
  ARGS((Widget fb, int num_items, fb_item items[]));
  /* Updates an existing browser */

#endif /* _BROWSER_H_ */
