#include "copyright.h"
#include "port.h"
#include <sys/time.h>
#include <signal.h>

#ifdef sequent

int  ignoreAlarm( sig, code, scp)
    int sig, code;
    struct sigcontext *scp;
{
    /* printf( "Alarm went off\n"); */
    return ;
}

/* This is a fairly accurate timer routine */
void Timer( val )
    int  val;			/* microseconds */
{
    struct timeval init, current;
    struct itimerval value, ovalue;
    struct sigvec sig, osig;
    extern int ignoreAlarm();

    sig.sv_handler = ignoreAlarm;
    sig.sv_mask = 0;
    sig.sv_onstack = 0;
    (void) sigvec( SIGALRM, &sig, &osig );

    value.it_interval.tv_sec = 0;
    value.it_interval.tv_usec = 0;
    value.it_value.tv_sec = 0;
    value.it_value.tv_usec = val;
    (void) setitimer( ITIMER_REAL, &value, &ovalue);
    (void) sigpause( 0 );		/* Wait for alarm to come */
    
    (void) sigvec( SIGALRM, &osig, 0 ); /* restore previous status */

    return;
}

#else	/* VAXes etc. */

void  ignoreAlarm()
{
    /* printf( "Alarm went off\n"); */
    return ;
}

/* This is a fairly accurate timer routine */
void Timer( val )
    int  val;			/* microseconds */
{
    struct itimerval value, ovalue;
    struct sigvec sig, osig;
    extern void ignoreAlarm();

    sig.sv_handler = ignoreAlarm;
    sig.sv_mask = 0;
    sig.sv_flags = 0;
/* The HP-UX documentation claims to support sigvec in signal.h,
	but this is not so (for version 8.07). */
#ifdef hpux
    (void) sigvector( SIGALRM, &sig, &osig );
#else
    (void) sigvec( SIGALRM, &sig, &osig );
#endif

    value.it_interval.tv_sec = 0;
    value.it_interval.tv_usec = 0;
    value.it_value.tv_sec = 0;
    value.it_value.tv_usec = val;
    (void) setitimer( ITIMER_REAL, &value, &ovalue);
    (void) sigpause( 0 );		/* Wait for alarm to come */
    
#ifdef hpux
    (void) sigvector( SIGALRM, &osig, 0 ); /* restore previos status */
#else
    (void) sigvec( SIGALRM, &osig, 0 ); /* restore previous status */
#endif
    return;
}

#endif
