      /* Boolean type */

typedef char bool;
#define TRUE 1
#define FALSE 0
#ifndef NULL
#define NULL 0
#endif

      /* Allocation */

/*
 * NEW(type)
 *     A pointer to a new (heap) object of given type.
 */

#define NEW(type) ((type *) malloc(sizeof(type)))

/*
 * NEWVEC(type,n)
 *     A pointer to a new (heap) vector of n objects of given type.
 */

#define NEWVEC(type,n) ((type *) calloc((unsigned) (n), sizeof(type)))

#define REALLOC(type, ptr, newcount) \
	(type *) realloc((char *) ptr, (unsigned) (sizeof(type) * (newcount)))

/* FREE(p) 
 *      Free any heap-allocated object, p
 */

#define FREE(p) ((void) free((char *) (p)))

    /* Infinite loop macro */

#define loop for(;;)


    /* Copying structures and arrays */

#define COPY(to,from) (void) (memcpy(&(to), &(from), sizeof(from)))
#define COPYVEC(to,from,n) (void) (memcpy((to), (from), \
					 sizeof((from)[0])*(n)))


