#include "copyright.h"
#include "port.h"

/*
 * initialization routines for an RPC application
 *
 * Rick L Spickelmier, 7/24/88
 */

/* #include "message.h" */
/* #include "selset.h"  */
/* #include "region.h"  */
/* #include "vemDM.h"   */
/* #include "list.h"    */
#include "rpcApp.h"

int RPCFloatingPointSame;



/*
 * dummy function to get lint to check UserMain arguments
 */

#ifdef lint
void
RPCDummyFunction()
{
    char *display;
    RPCSpot *spot;
    lsList cmdList;
    long uow;
    RPCFunction **array;

    display = "shambhala:0";
    spot = (RPCSpot *) 0;
    cmdList = lsCreate();
    uow = 0;
    array = (RPCFunction **) 0;

    (void) UserMain(display, spot, cmdList, uow, array);

    RPCDummyFunction();	/* to get rid of 'but never used' message */

    return;
}
#endif /* lint */


/*
 * tell VEM about the application
 *
 * Returns:
 *   OCT_OK	if the initialization succeeded	
 *   OCT_ERROR	if anything failed
 *
 */
octStatus
vemInitializeApplication(display, spot, cmdList, userOptionWord)
char **display;
RPCSpot *spot;
lsList *cmdList;
long *userOptionWord;
{
    long format;
    double dbl;
    long *lngs;

    RPCDemonTable = st_init_table(st_numcmp, st_numhash);

    RPCASSERT(RPCSendLong(VEM_INITIALIZE_APPLICATION_FUNCTION, RPCSendStream));
    RPCASSERT(RPCSendLong(RPC_VERSION, RPCSendStream));

    /* send the process id - for possible killing */
    RPCASSERT(RPCSendLong((long) getpid(), RPCSendStream));

    /* ship across floating point number format information */
    dbl = RPCDOUBLE;
    lngs = (long *) &dbl;
    RPCASSERT(RPCSendLong((long) lngs[0], RPCSendStream));
    RPCASSERT(RPCSendLong((long) lngs[1], RPCSendStream));
    
    RPCFLUSH(RPCSendStream);

    /* get the floating point number format information */
    RPCASSERT(RPCReceiveLong(&format, RPCReceiveStream));
    if (format == OCT_OK) {
	RPCFloatingPointSame = 1;
    } else {
	RPCFloatingPointSame = 0;
    }
	 
    /* get the display */
    RPCASSERT(RPCReceiveString(display, RPCReceiveStream));
    RPCASSERT(RPCReceiveVemArgs(spot, cmdList, userOptionWord, RPCReceiveStream));
    return OCT_OK;
}


octStatus
vemSendMenu(array, count)
RPCFunction array[];
long count;
{
    long returnCode;
    int i;

    RPCASSERT(RPCSendLong(VEM_SEND_MENU_FUNCTION, RPCSendStream));
    RPCASSERT(RPCSendLong(count, RPCSendStream));

    /* send the pane and menu strings, and the keybindings */
    for (i = 0; i < count; i++) {
	RPCASSERT(RPCSendString(array[i].paneString, RPCSendStream));
	RPCASSERT(RPCSendString(array[i].menuString, RPCSendStream));
	RPCASSERT(RPCSendString(array[i].keyBinding, RPCSendStream));
	RPCASSERT(RPCSendLong(array[i].userOptionWord, RPCSendStream));
    }
    RPCFLUSH(RPCSendStream);

    RPCASSERT(RPCReceiveLong(&returnCode, RPCReceiveStream));

    return (octStatus) returnCode;
}

