/*
 * Short testing program for the typescript widget
 */

#include <stdio.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Command.h>
#include "ts.h"

#define MAX_ARGS	10

char *XtClassName = "TStest";
static void XtStart();

void dump_core(msg)
String msg;
{
    (void) fprintf(stderr, "Fatal toolkit error: %s\n", msg);
    abort();
}

main(argc, argv)
int argc;
char *argv[];
{
    Widget top_level_widget;
    XtAppContext context;
    Display *disp;
    int arg_len;
    Arg arg_list[MAX_ARGS];

    XtSetErrorHandler(dump_core);
    XtToolkitInitialize();
    context = XtCreateApplicationContext();
    disp = XtOpenDisplay(context, "", argv[0], XtClassName,
			 (XrmOptionDescRec *) 0, 0,
			 &argc, argv);
    arg_len = 0;
    XtSetArg(arg_list[arg_len], XtNallowShellResize, True);	arg_len++;
    XtSetArg(arg_list[arg_len], XtNinput, True);		arg_len++;
    top_level_widget = XtAppCreateShell(argv[0], XtClassName,
					applicationShellWidgetClass,
					disp, arg_list, arg_len);
    XtStart(argc, argv, context, top_level_widget);
    XtAppMainLoop(context);
    return 0;
}

static void std_char(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
    ts_call_data *data = (ts_call_data *) call;
    int i;

    for (i = 0;  i < data->len;  i++) {
	tsWriteChar(w, (int) (data->buf[i]));
    }
}

static void done(w, client, call)
Widget w;
XtPointer client;
XtPointer call;
{
    XtDestroyWidget((Widget) client);
}

static void XtStart(argc, argv, app, tw)
int argc;
char *argv[];
XtAppContext app;
Widget tw;
{
    Widget pane, cmd, ts;

    pane = XtCreateManagedWidget("pane", panedWidgetClass, tw, 0, 0);
    cmd = XtCreateManagedWidget("cmd", commandWidgetClass, pane, 0, 0);
    XtAddCallback(cmd, XtNcallback, done, (XtPointer) tw);
    ts = tsCreate(app, "console", pane, 100, std_char, (caddr_t) 0,
		  (ArgList) 0, 0);
    XtRealizeWidget(tw);
}
